function AppConnector() {

	this.appendTempString = function (key, s) {
		if (!this.tempData)
			this.tempData = {};
		if (!this.tempData[key])
			this.tempData[key] = s;
		else
			this.tempData[key]=this.tempData[key]+s;
	}
	
    this.clearTempString = function (key) {
    //console.log("Clearing tempString");
       this.tempData = undefined;
     }

	this.setBackboneJSON = function (s) {
		if (typeof s === 'string')
			this.backboneJSON = JSON.parse(s);
		else
			this.backboneJSON = s;
	}

	this.getBackboneJSON = function () {
		return this.backboneJSON;
	}

	this.setRoutingJSON = function (s) {
		if (typeof s === 'string')
			this.routingJSON = JSON.parse(s);
		else
			this.routingJSON = s;
	}

	this.getRoutingJSON = function () {
		return this.routingJSON;
	}

	this.setLabelsJSON = function (s) {
		if (typeof s === 'string') {
			this.labelsJSON = JSON.parse(s);
		} else {
			//console.log("s=" + typeof s)
			this.labelsJSON = s;
		}
	}

	this.getLabelsJSON = function () {
		return this.labelsJSON;
	}

	this.setStaticMarkersJSON = function (s) {
		if (typeof s === 'string')
			this.staticMarkersJSON = JSON.parse(s);
		else
			this.staticMarkersJSON = s;
	}

	this.getStaticMarkersJSON = function () {
		return this.staticMarkersJSON;
	}

	this.setPinboardMarkersJSON = function (s) {
		this.pbMarkersJSON = s;
	}

	this.getPinboardMarkersJSON = function () {
		return this.pbMarkersJSON;
	}

	this.setActivePinboardMarkersJSON = function (s) {
		if (typeof s === 'string')
			this.activePBMarkersJSON = JSON.parse(s);
		else
			this.activePBMarkersJSON = s;
	}

	this.getActivePinboardMarkersJSON = function () {
		return this.activePBMarkersJSON;
	}

	this.setEventsJSON = function (s) {
		if (typeof s === 'string')
			this.eventsJSON = JSON.parse(s);
		else
			this.eventsJSON = s;
	}

	this.getEventsJSON = function () {
		return this.eventsJSON;
	}

	// error handling
	this.handleError = function (id, s, noPopup) {
		console.log('handleError: ' + id);
		// 1 - location uknown
		// 2 - location outside viewable bounds
		// 3 - path not found
		//alert(s);
		//window.location.href = "yourapp://www.yourapp.com/warningMessage?id=" + id;

		if (noPopup){
			$('#nav-bar-navigation').hide();
			$('#nav-bar-time').hide();
			$('#nav_error').text(s);
			$('#nav_error').show();
		} else {
			var title = $('#warning-modal-sm').find('#warning-modal-title')
			title.text(langString (language, 'warning_modal_name'));
			var body = $('#warning-modal-sm').find('#warning-modal-body');
			body.html(s);
			$('#warning-modal-sm').modal('toggle');	
			
			
		}
		

	}
	// get info
	this.handleGetInfoForPinboardItem = function (id) {
		// implement

	}

	// location update,  projects to 'EPSG:3857'
	this.updateUserLocationLonLat = function (lonLat, beaconData) {
		navigatorCore.locationManager.handleLocationFoundExtPlusBeacons(ol.proj.fromLonLat(lonLat),beaconData);
	}
	// location update
	this.updateUserLocation = function (coord, beaconData) {
		navigatorCore.locationManager.handleLocationFoundExtPlusBeacons(coord,beaconData);
	}

	// find location using IPS
	this.updateUserLocationIPS = function (beaconData) {
		navigatorCore.locationManager.ips.determineUserLocation(beaconData);
	}
	//show on map for
	this.showOnMap = function (location_id) {
		showOnMap(location_id)
	}
	
	this.recordStatistic = function (statistic) {

	}
	
	this.getCurrentNavDirections = function () {
		return navigatorCore.navPathAssistant.getCurrentDirections();
	}
	
	this.getJSONStringForCurrentNavDirections = function () {
	return JSON.stringify(navigatorCore.navPathAssistant.getCurrentDirections());
	}
	
	// clicks handling
	this.buttonARClicked = function () {
		if(isAndroid()){
			console.log("buttonARClicked android");
		} else {
			console.log("buttonARClicked iOS"); 
			window.location = "app://arView";   
		}
	
	}

	this.locationViewMoreClicked = function (event) {	
		var location_id = event.target.getAttribute('location_id');
	//	console.log("locationViewMoreClicked"+location_id);
	//	return;
		if(isAndroid()){
			console.log("locationViewMoreClicked android : " + location_id);
			JSInterface.mapLocationClicked(location_id);
		} else {
			console.log("locationViewMoreClicked iOS");
			window.location = 'http://popup-link?locationid=' + location_id;  
		}
	}
	
    this.tourViewMoreClicked = function (event) {
    	var location_id = event.target.getAttribute('location_id');
    	if (isAndroid()) {
    		console.log("tourLocationClicked android : " + location_id);
    		JSInterface.tourLocationClicked(location_id);
    	} else {
    		console.log("tourLocationClicked iOS");
    		window.location = 'http://popup-link?locationid=' + location_id;
    	}
    }
	this.tempMarkerViewMoreClicked = function (event) {	
	var extid = event.target.getAttribute('extid');
		if(isAndroid()){
			console.log("tempMarkerViewMoreClicked android");
		} else {
			console.log("tempMarkerViewMoreClicked iOS");
			window.location = 'http://popup-link?extid=' + extid;
		}
	
	}
	
	this.locationAddToMyDayClicked = function (itemData) {	
		var location_id = event.target.getAttribute('location_id');
		var markerid = event.target.getAttribute('markerid');
		if(isAndroid()){
			console.log("locationAddToMyDayClicked android");
			JSInterface.addToMyDayClicked(location_id);
		} else {
			console.log("locationAddToMyDayClicked iOS");
			//window.location = "http://www.google.com/";   
			window.location = 'http://add-to-my-day-link?locationid=' + location_id + '&markerid=' + markerid;
		}
	
	}
	
	this.finishTourClicked = function () {	
		if(isAndroid()){
			console.log("finishTourClicked android");
			JSInterface.finishTour();
		} else {
			console.log("finishTourClicked iOS");
			//window.location = "http://www.google.com/";   
			window.location = 'app://finish-tour';  
		}
	
	}
	this.registerAsVisisted = function (itemID) {	
		if(isAndroid()){
			console.log("registerAsVisisted android");
			JSInterface.itemVisited(itemID);
		} else {
			console.log("registerAsVisisted iOS");
			window.location.href = "app://registerAsVisited?itemID=" + itemID;
		}
	
	}
}